﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Runtime.Caching;

namespace CacheSample
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // 获取默认的 MemoryCache 实例
        MemoryCache cache = MemoryCache.Default;

        // 用于存储缓存项的键名
        const string CACHE_ITEM_NAME = "my_data";

        private void OnReadClick(object sender, EventArgs e)
        {
            string content = string.Empty;
            // 首先判缓存项是否存在
            if (cache.Contains(CACHE_ITEM_NAME))
            {
                // 如果缓存项有效
                // 就从缓存中读取数据
                DateTime dt = (DateTime)cache[CACHE_ITEM_NAME];
                content = $"读到 {dt.ToLongTimeString()}";
            }
            else
            {
                // 如果缓存项不存在，或已过期
                // 则重新把当前时间写入缓存
                DateTime dt = DateTime.Now;
                cache.Set(CACHE_ITEM_NAME, dt, DateTimeOffset.Now.AddSeconds(20));
                content = $"读到 {dt.ToLongTimeString()}";
            }
            listBox1.Items.Add(content);
        }

        private void OnClearItems(object sender, EventArgs e)
        {
            listBox1.Items.Clear();
        }
    }
}
